package assignment1;

public class ParkingLot {
	
	private ParkingSpace[] parkingSpaces;
	
	public ParkingLot(int capacity) {
		if ( capacity <= 0 ) {
			capacity = 40;
			System.out.println("Error! The capacity of an array has to be a positive number");
		} 
		parkingSpaces = new ParkingSpace[capacity];
		for (int i = 0; i < parkingSpaces.length; i++) {
			parkingSpaces[i] = new ParkingSpace();
			parkingSpaces[i].setFree(true);
		}
	}
	
	public boolean isThereFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() )
				return true;
		}
		return false;
	}
	
	private int indexOfFreeSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() )
				return i;
		}
		return -1;
	}
	
	public void parkTheVehicle(String regNum) {
		if ( indexOfFreeSpace() >= 0 ) {
			int index = indexOfFreeSpace();
			parkingSpaces[index].setFree(false);
			parkingSpaces[index].setRegistrationNumber(regNum);
		} else
			System.out.println("The parking lot is already full!");
	}
	
	public boolean isVehicleOnTheParkingLot(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() == false &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return true;
		}
		return false;
	}
	
	private int indexOfVehicleOnTheParkingLot(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() == false &&
					parkingSpaces[i].getRegistrationNumber().equals(regNum))
				return i;
		}
		return -1;
	}
	
	public void removeTheVehicle(String regNum) {
		int index = indexOfVehicleOnTheParkingLot(regNum);
		if ( index >= 0 ) {
			parkingSpaces[index].setFree(true);
			parkingSpaces[index].setRegistrationNumber(null);
		} else
			System.out.println("The vehicle is not on the parking lot");
	}

}







