package assignment1;

public class ParkingLot {
	
	private ParkingSpace[] parkingSpaces;
	
	public ParkingLot(int capacity) {
		if ( capacity <= 0 ) {
			capacity = 40;
			System.out.println("Error! The capacity of the array "
					+ "must be a positive number");
		}
		parkingSpaces = new ParkingSpace[capacity];
		for (int i = 0; i < parkingSpaces.length; i++) {
			parkingSpaces[i] = new ParkingSpace();
			parkingSpaces[i].setFree(true);
		}
			
	}
	
	public boolean anyFreeParkingSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() )
				return true;
		}
		return false;
	}
	
	private int indexOfFreeParkingSpace() {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if ( parkingSpaces[i].isFree() )
				return i;
		}
		return -1;
	}
	
	public void parkTheVehicle(String regNum) {
		int index = indexOfFreeParkingSpace();
		if ( index >= 0 ) {
			parkingSpaces[index].setFree(false);
			parkingSpaces[index].setRegistrationNumber(regNum);
		} else
			System.out.println("Error! There is no free space on this parking");
	}
	
	public int checkingVehicles(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if(parkingSpaces[i].isFree() == false &&
				regNum.equals(parkingSpaces[i].getRegistrationNumber())) {
			return i;	
			}
		}
		return -1;
	}
	
	public boolean checkingVehicles1(String regNum) {
		for (int i = 0; i < parkingSpaces.length; i++) {
			if(parkingSpaces[i].isFree() == false &&
				regNum.equals(parkingSpaces[i].getRegistrationNumber())) {
			return true;	
			}
		}
		return false;
	}
	
	public void remove (String regNum){
		if(checkingVehicles1(regNum)){
			int i = checkingVehicles(regNum);
			parkingSpaces[i].setFree(true);
			parkingSpaces[i].setRegistrationNumber(null);
		}else System.out.println("There is no such vehicle!");
		
	}
	
}









